/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.gov.sunderland.ccms.model.test;

import com.sun.appserv.security.ProgrammaticLogin;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.glassfish.api.ActionReport;
import org.glassfish.api.embedded.*;
import org.glassfish.api.admin.*;

/**
 *  //         Logger.getLogger("javax.enterprise.system").setLevel(Level.FINEST);
        Logger.getLogger("").getHandlers()[0].setLevel(Level.FINEST);
 * @author Magnus.Smith
 */
public class GlassFishTestHelper {


    public static void createFileUser(String userName, String userPassword, String userGroups) throws Exception { 
        // Get the running arquillian embedded glassfish
        Server server = Server.getServer(Server.getServerNames().get(0));
        String command = "create-file-user";
        ParameterMap params = new ParameterMap();
        params.add("userpassword", userPassword);
        params.add("groups", userGroups);
        params.add("username", userName);
        CommandRunner runner = server.getHabitat().getComponent(CommandRunner.class);
        ActionReport report = server.getHabitat().getComponent(ActionReport.class);
        runner.getCommandInvocation(command, report).parameters(params).execute();

        if (report.getMessage() != null) {
            throw new Exception(String.format("Failed to create user : %s - message %s",
                    userName, report.getMessage()), report.getFailureCause());
        }
    }

    public static boolean loginFileUser(String userName, String userPassword) throws Exception {
        ProgrammaticLogin pgLogin = new ProgrammaticLogin();
        return pgLogin.login(userName, userPassword.toCharArray(), "fileRealm", true);
    }
}
